text is drawn 1-pixel to the left, cutting the text

12/19/2017 06:56 AM - Sergey Ivanovskiy
Description

History

#1 - 12/19/2017 09:25 AM - Sergey Ivanovskiy

- File SwingAndWebTextInBrowser.png added

It seems that header's and cell's content in tables incorrectly positioned. It can be observed for the web and swing clients.

 

#2 - 12/19/2017 09:27 AM - Sergey Ivanovskiy
- File TextInBrowser.png added

The web client displays text in tables incorrectly too.

 

#3 - 12/19/2017 09:30 AM - Sergey Ivanovskiy

- Subject changed from The web client displays texts 1-pixel to the left, cutting the text to The texts are drawn 1-pixel to the left, cutting the text

#4 - 12/19/2017 09:40 AM - Sergey Ivanovskiy

I didn't implement this function. Please explain the reasons that in the code below the text x-position coordinate is reduced by a pixel

CanvasRenderer.prototype.drawText = function(text, x, y, centered)

{

   if (centered)

   {

      // in this case, the "y" is the height in which it needs to be vertically centered

      this.ctx.textBaseline = 'middle';

      ++y;

   }

   else

   {

      this.ctx.textBaseline = 'alphabetic'; // matches the Swing's baseline

      --y;

   }

   --x;

   var cfont = p2j.screen.getCurrentFont();

   /*start debug*/

   //   var txtHeight = p2j.fonts.getTextHeight(cfont, text);

   //   var textWidth = p2j.fonts.getTextWidth(cfont, text);

   //   

   //   if (centered)

   //   {

   //      this.drawRect(x, y - txtHeight / 2, textWidth, txtHeight, new Array(255, 255, 0), false);

   //   }

   //   else 

   //   {

   //      this.drawRect(x, y - 3 * txtHeight / 4, textWidth, txtHeight, new Array(0, 255, 0), false);

   //   }

   /*end debug*/
   this.ctx.fillText(text, x, y);

   if (p2j.fonts.isUnderlined(cfont))

   {

      // if the style is underline, draw a line under the text

      var txtHeight = p2j.fonts.getTextHeight(cfont, text);

      var textWidth = p2j.fonts.getTextWidth(cfont, text);

      var x1 = x;

      var x2 = x + textWidth;

      if (centered)

      {

         y = y + Math.round(txtHeight / 2) - Math.round(txtHeight / 6) + 1;

      }

      this.strokeLineSegment(x1, y, x2, y, this.rawColor);

   }

}

#5 - 12/19/2017 11:06 AM - Sergey Ivanovskiy

Committed revision 11280(3394a) should fix the web text position along a horizontal. It seems that the other text position issues are related to the

common code (browser). Should I work on these browser issues?

#6 - 12/19/2017 11:15 AM - Greg Shah

Should I work on these browser issues?

 

Yes, but make sure you get input from Stanislav so that you don't cause regressions.  He is our browse guru.

#7 - 12/19/2017 12:21 PM - Sergey Ivanovskiy

OK. It seems that table labels are displayed 1-pixel left due to this code ClassicTheme.this.drawBrowseCellText

   protected void drawBrowseCellText(BrowseColumnGuiImpl column,

                                     GuiDriver gd,

                                     boolean label,

                                     boolean selectedRow,

                                     String text,

                                     NativeRectangle clipRectangle,

                                     int lineNumber,
                                     int viewportRowIndex)

   {

      setBrowseCellForegroundColor(column, gd, label, selectedRow, viewportRowIndex);

      FontDetails fd = label ? column.getLabelFontDetails() : column.getColumnFontDetails();

      gd.setGuiFont(fd);

      int y = label ? column.getLabelTextTopOffset() : column.getCellTextTopOffset();

      y += fd.legacyHeight * lineNumber;

      int x = 0;

      if (Browse.isRightAligned(column))

      {

         x = clipRectangle.width() - column.getTextWidth(text,

               label ? column.getLabelFontNum() : column.getColumnFontNum());

      }

      if (label && !column.isLastColumn())

      {

         --x; // <--------------------- reducing x-coordinate ?

      }

      gd.drawString(text, x, y);

   }

Also there is suspected code that calculates the label clipping rectangle in the case of right alignment labels by these functions

BrowseColumnGui.this.getCellTextClipPoint(int viewportIndex) and BrowseColumnGui.this.getCellTextClipRectangle(NativePoint point).

#8 - 12/19/2017 01:13 PM - Stanislav Lomany

It seems that table labels are displayed 1-pixel left due to this code ClassicTheme.this.drawBrowseCellText

 

This was added in the very first version of ClassicTheme by Ovidiu, so I cannot comment. As to me, just fix it and check positioning and clipping for

swing/web, different themes, first/last/middle/last locked columns, label/cell text, left/right aligned text.
#9 - 12/19/2017 01:19 PM - Ovidiu Maxiniuc

I cannot remember why I added that special processing. Most likely I adjusted that based on offset revealed when comparing the two layers in Gimp.

It is possible that the font configuration to had been different. If it is wrong, please drop it.

#10 - 12/20/2017 03:24 AM - Sergey Ivanovskiy

Ovidiu Maxiniuc wrote:

It is possible that the font configuration to had been different. If it is wrong, please drop it.

 

Ovidiu, could you help with correct font setup? It is supposed that text-metrics.xml is filled with all strings with their metrics. I have text-metrics.xml of

59 Mb dated 29.11.2017.

#11 - 12/20/2017 03:50 AM - Ovidiu Maxiniuc

The text-metrics.xml for AW was last updated by Constantin on Tue 2017-11-28 22:20:15 +0200 as revno 110.

I don't know if I made myself very clear. When I said font configuration I meant the fonts actually used by FWD. For example, I don't recall if I was

using MS Sans Serif or Microsoft Sans Serif (see #2765). They look similar but might be slightly different here and there. Probably I was using the

unlicensed one at that time. So I suggested to drop my code that translate the text 1 pixel to the left in case the correct font gets cut because of it.

#12 - 12/20/2017 04:00 AM - Sergey Ivanovskiy

Thank you, if we don't shift the text by 1 pixel to the left, then some table headers don't fit the column and some right aligned column headers are not

fitted the column width too. Planning to check the formula and the column widths with the original ones in these cases but at this moment I don't have

a solution.

#13 - 12/21/2017 02:40 PM - Sergey Ivanovskiy

Please review committed revision 11296 that should fix drawing of labels with help of #3394-88.

#14 - 12/21/2017 03:12 PM - Sergey Ivanovskiy

Please review committed revision 11297.

#15 - 12/21/2017 03:44 PM - Greg Shah

Code Review Task Branch 3394a Revisions 11296/7

I don't see a specific issue with the changes.  However, the validity of the changes to drawBrowseCellText() are not intuitively obvious to me.

Does the general removal of the --x for the label case avoid the left justified labels being truncated?

The cell text still seems too close the left side of the cell.  There seems to be no spacing, but I think there is at least a pixel of spacing in the 4GL.  Am

I mistaken?

Stanislav/Hynek: please review.
#16 - 12/21/2017 05:56 PM - Hynek Cihlar

Greg Shah wrote:

Stanislav/Hynek: please review.

 

Formally, I don't see anything wrong with the code. Maybe I would change the following

x -= (BrowseColumnGuiImpl.LABEL_OFFSET_RIGHT + BrowseColumnGuiImpl.LABEL_OFFSET_LEFT);

int t = x - 1;

x = (t > 0) ? t : 0;

 

To something less cryptic:

x -= (BrowseColumnGuiImpl.LABEL_OFFSET_RIGHT + BrowseColumnGuiImpl.LABEL_OFFSET_LEFT + 1);

if (x < 0)

{

   x = 0;

}

 

But I can't say whether the code is functionally correct.

#17 - 12/22/2017 04:52 AM - Sergey Ivanovskiy

Yes. Agree, committed rev 11301.

#18 - 12/22/2017 07:09 AM - Greg Shah

If Stanislav is OK with these changes, then we are good to go.

#19 - 12/22/2017 07:10 AM - Stanislav Lomany

I'm not good, wait a bit.
#20 - 12/22/2017 07:43 AM - Stanislav Lomany

- File 95-97.png added

It is not clear if actual P2J version (rev 11295) has issues with clipping (please use fonts without anti-aliasing for testing), however it is clear that rev

11297 has. Also note that rev 11297 has wrong column widths.

check positioning and clipping for swing/web, different themes, first/last/middle/last locked columns, label/cell text, left/right aligned text.

 

I mean it.
Testcase:

DEF TEMP-TABLE tt FIELD f1 AS INTEGER column-label "WWWWWW" 

                  FIELD f2 AS character format "x(20)" column-label "WWWWWW" 

                  FIELD f3 AS character index idx f1.

def var i as integer.

def var str as char.
repeat i = 1 to 20:

   CREATE tt. tt.f1 = i. 

   tt.f2 = "second " + string(i). 

   tt.f3 = "third " + string(i).

end.

release tt.

def buffer xtt for tt.

DEFINE QUERY q FOR tt SCROLLING.

OPEN QUERY q FOR EACH tt.

DEF BROWSE br QUERY q 

DISPLAY 

     tt.f1 width 5

     tt.f2 width 5

     tt.f3 

   WITH 12 down TITLE "Static browse" separators.

DEF FRAME fr br SKIP(1) str 

  WITH TITLE "Frame" SIZE 70 BY 15 NO-LABELS.

enable br with frame fr.

WAIT-FOR WINDOW-CLOSE OF DEFAULT-WINDOW.

#21 - 12/22/2017 08:01 AM - Sergey Ivanovskiy

Stanislav Lomany wrote:

It is not clear if actual P2J version (rev 11295) has issues with clipping (please use fonts without anti-aliasing for testing), however it is clear that

rev 11297 has. Also note that rev 11297 has wrong column widths.

 

Stanislav, please describe font settings thoroughly, what are fonts without anti-aliasing? Is it true that P2J rev 11295 has correct column widths for the

test you provided?

Did you run your test and make a screen shot for the Web client or the Swing client?
#22 - 12/22/2017 08:03 AM - Sergey Ivanovskiy

Did you build a font-metrics file for the strings from your test?

#23 - 12/22/2017 08:12 AM - Sergey Ivanovskiy

The rev.11297, 11301 don't make changes for column widths. It is supposed that they are calculated correctly.

#24 - 12/22/2017 08:22 AM - Stanislav Lomany

Stanislav, please describe font settings thoroughly, what are fonts without anti-aliasing?

 

I don't know, but the browse title ("Static browse") has one without anti-aliasing.

Is it true that P2J rev 11295 has correct column widths for the test you provided?

 

They match on the screenshot.

Did you run your test and make a screen shot for the Web client or the Swing client?

 

Swing.

Did you build a font-metrics file for the strings from your test?

 

No.

The rev.11297, 11301 don't make changes for column widths.

 

You've changed the constants LABEL_OFFSET_LEFT and LABEL_OFFSET_RIGHT used by doLayout() -> getColumnPadding()
#25 - 12/22/2017 08:49 AM - Sergey Ivanovskiy

Stanislav Lomany wrote:

Stanislav, please describe font settings thoroughly, what are fonts without anti-aliasing?

 

I don't know, but the browse title ("Static browse") has one without anti-aliasing.

 

The problem is that I don't understand it too, otherwise this issue will be fixed.

Greg, I have no ideas how to proceed and I would like to recall that the same font unresolved issue was considered in the last iteration when Hotel

GUI had been developed.

Is it true that P2J rev 11295 has correct column widths for the test you provided?

 

They match on the screenshot.

 

The rev.11297, 11301 don't make changes for column widths.

 

You've changed the constants LABEL_OFFSET_LEFT and LABEL_OFFSET_RIGHT used by doLayout() -> getColumnPadding()

 

Do these changes affect column widths?
#26 - 12/22/2017 09:07 AM - Sergey Ivanovskiy

Is this code from BrowseGuiImpl.doLayout() correct?

      // Update column.WIDTH attribute.

      int colNo = getColumnCount();

      for (int i = 0; i < colNo; i++)

      {

         BrowseColumnGuiImpl column = getColumn(i);

         int width = column.physicalDimension().width;

         width -= column.getColumnPadding(); // <----------------------------------------why the width is redu

ced?

         column.config().widthChars = cc.widthFromNative(width);

         column.config().widthPixels = width;

      }

#27 - 12/22/2017 09:09 AM - Greg Shah

Stanislav: Please take this task.  Please remove the changes for 11296/11297 such that it won't cause regressions.  If you would do this quickly, we

are trying to get 3394a into the trunk.

Constantin: It seems this is important to put into 3394a ASAP.

Sergey: You can move to other tasks.

#28 - 12/22/2017 09:13 AM - Constantin Asofiei

Greg Shah wrote:

Stanislav: Please take this task.  Please remove the changes for 11296/11297 such that it won't cause regressions.  If you would do this quickly,

we are trying to get 3394a into the trunk.

Constantin: It seems this is important to put into 3394a ASAP.

 

I'm OK with this.

#29 - 12/22/2017 09:21 AM - Stanislav Lomany
Stanislav: Please take this task.  Please remove the changes for 11296/11297 such that it won't cause regressions.  If you would do this quickly,

we are trying to get 3394a into the trunk.

 

Do you want me to revert 11296/11297 and then you merge 3394 and I check into another branch OR you want my to try to fix this issue in the limited

amount of time?

#30 - 12/22/2017 09:23 AM - Greg Shah

Do you want me to revert 11296/11297 and then you merge 3394 and I check into another branch

 

This one.  The fix should be done in a separate branch.

#31 - 12/22/2017 09:23 AM - Constantin Asofiei

Stanislav Lomany wrote:

Stanislav: Please take this task.  Please remove the changes for 11296/11297 such that it won't cause regressions.  If you would do this

quickly, we are trying to get 3394a into the trunk.

 

Do you want me to revert 11296/11297 and then you merge 3394 and I check into another branch OR you want my to try to fix this issue in the

limited amount of time?

 

After rebase the revisions in 3394a are 11299/11300 - although please make sure these are the correct revisions before rolling back the changes.

So, rollback these two revisions in 3394a and commit them.  After that, you can consider 3394a frozen again - I'm waiting for runtime testing to

complete, do some manual testing in the large GUI app and after that merge it to trunk.

#32 - 12/22/2017 10:08 AM - Stanislav Lomany
So, rollback these two revisions in 3394a and commit them.

 

Done.

#33 - 12/23/2017 04:24 AM - Stanislav Lomany

- Assignee set to Stanislav Lomany

#34 - 01/05/2018 10:36 AM - Stanislav Lomany

- Status changed from New to WIP

I do not see the issue in the hotel app either Swing or web using the current trunk. Please confirm.

#35 - 01/05/2018 11:38 AM - Greg Shah

- File 3435a_browse_header_text_positioning_issue_20180105.png added

I still see the issue.  This is using the latest 3435a:

 

If you see something different, I wonder if the issue is related to the fonts in use.  I'm using the default (no overrides in deploy/server/fonts/.
#36 - 01/12/2018 05:54 AM - Stanislav Lomany

FYI.

To draw a columns separator we should decide to which column it belongs. In original design a column contained its left separator, however when we

switched to UI themes, a column began to contain its right separator instead.

There is 4GL quirk when then right border of the locked panel is not fully drawn and you can see 1px of the underlying scrolling panel which makes

me think that the original design was correct (but technically it does not state it 100%). Other that this case I'm not aware of other cases which tell

which design is correct, so I'm leaving everything as is.

#37 - 01/17/2018 04:40 PM - Greg Shah

What is the status of this task?

#38 - 01/17/2018 04:51 PM - Stanislav Lomany

Just finished, going to update the branch and check for regressions in AW.

#39 - 01/18/2018 09:22 AM - Stanislav Lomany

The fix is committed into the branch 3435a rev 11256.

#40 - 01/18/2018 09:23 AM - Stanislav Lomany

- Status changed from WIP to Review

#41 - 01/18/2018 01:10 PM - Greg Shah

Code Review Task Branch 3435a Revision 11256

I'm fine with the changes.

#42 - 02/05/2018 11:15 AM - Greg Shah

- % Done changed from 0 to 100

- Subject changed from The texts are drawn 1-pixel to the left, cutting the text to text is drawn 1-pixel to the left, cutting the text

- Status changed from Review to Closed

- Start date deleted (12/19/2017)

Branch 3435a was merged to trunk as revision 11217.

Files

SwingAndWebTextInBrowser.png 240 KB 12/19/2017 Sergey Ivanovskiy

TextInBrowser.png 13.9 KB 12/19/2017 Sergey Ivanovskiy

95-97.png 29.9 KB 12/22/2017 Stanislav Lomany

3435a_browse_header_text_positioning_issue_20180105.png 28.2 KB 01/05/2018 Greg Shah

Powered by TCPDF (www.tcpdf.org)

05/18/2024 15/15

http://www.tcpdf.org

